---
title: InputEvent.inputType
slug: Web/API/InputEvent/inputType
tags:
  - API
  - DOM
  - DOM Events
  - Input
  - InputEvent
  - Property
  - Reference
  - events
  - inputType
---
<div>{{APIRef("DOM Events")}}</div>

<p>The <strong><code>inputType</code></strong> read-only property of the {{domxref("InputEvent")}} interface returns the type of change made to editible content. Possible changes include for example inserting, deleting, and formatting text.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>aString</em> = <em>inputEvent</em>.inputType;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} containing the type of input that was made. There are many possible values, such as <code>insertText</code>, <code>deleteContentBackward</code>, <code>insertFromPaste</code>, and <code>formatBold</code>. For a complete list of the available input types, see the <a href="https://rawgit.com/w3c/input-events/v1/index.html#interface-InputEvent-Attributes">Attributes section of the Input Events Level 1 spec</a>.</p>

<h2 id="Examples">Examples</h2>

<p>This example logs the <code>inputType</code> for <a href="/en-US/docs/Web/API/HTMLElement/input_event">input events</a> on an editable {{htmlElement("div")}}.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;p id="log"&gt;Input type: &lt;/p&gt;
&lt;div contenteditable="true" style="margin: 20px;padding: 20px;border:2px dashed red;"&gt;
  &lt;p&gt;Some sample text. Try inserting line breaks, or deleting text in different ways, or pasting different content in.&lt;/p&gt;
  &lt;hr&gt;
  &lt;ul&gt;
    &lt;li&gt;A sample&lt;/li&gt;
    &lt;li&gt;bulleted&lt;/li&gt;
    &lt;li&gt;list.&lt;/li&gt;
  &lt;/ul&gt;
  &lt;p&gt;Another paragraph.&lt;/p&gt;
&lt;/div&gt;</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js notranslate">const log = document.getElementById('log');
const editable = document.querySelector('div[contenteditable]');
editable.addEventListener('input', logInputType);

function logInputType(event) {
  log.textContent = `Input type: ${event.inputType}`;
}
</pre>

<h3 id="Result">Result</h3>

<p>Try editing the text inside the <code>&lt;div&gt;</code> and see what happens.</p>

<p>{{EmbedLiveSample("Examples", '100%', 500)}}</p>

<div class="notecard note">
<p><strong>Note</strong>: See also <a href="https://d-toybox.com/studio/lib/input_event_viewer.html">Masayuki Nakano's InputEvent test suite</a> for a more detailed example.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('UI Events','#dom-inputevent-inputtype','inputType')}}</td>
   <td>{{Spec2('UI Events')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.InputEvent.inputType")}}</p>
</div>
